

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was CollageConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

####################################################################################

set(Collage_PREFIX_DIR ${PACKAGE_PREFIX_DIR})
if(CMAKE_VERSION VERSION_LESS 2.8.3) # WAR bug
  get_filename_component(CMAKE_CURRENT_LIST_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
endif()
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})
# Copyright (c) 2014 Stefan.Eilemann@epfl.ch

# Provides common_package(Name args) which improves find_package.
# First invokes find_package with all the given arguments, and then
# falls back to using pkg_config if available. The pkg_config path
# does only implement the version, REQUIRED and QUIET find_package
# arguments (e.g. no COMPONENTS)

find_package(PkgConfig)
set(ENV{PKG_CONFIG_PATH}
  "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")

macro(COMMON_PACKAGE Name)
  string(TOUPPER ${Name} COMMON_PACKAGE_NAME)
  set(COMMON_PACKAGE_ARGS ${ARGN}) # ARGN is not a list. make one.
  set(COMMON_PACKAGE_VERSION)

  if(COMMON_PACKAGE_ARGS)
    list(GET COMMON_PACKAGE_ARGS 0 COMMON_PACKAGE_VERSION)
    if(COMMON_PACKAGE_VERSION MATCHES "^[0-9.]+$") # is a version
      set(COMMON_PACKAGE_VERSION ">=${COMMON_PACKAGE_VERSION}")
    else()
      set(COMMON_PACKAGE_VERSION)
    endif()
  endif()

  list(FIND COMMON_PACKAGE_ARGS "QUIET" COMMON_PACKAGE_QUIET_POS)
  if(COMMON_PACKAGE_QUIET_POS EQUAL -1)
    set(COMMON_PACKAGE_QUIET)
  else()
    set(COMMON_PACKAGE_QUIET "QUIET")
  endif()

  list(FIND COMMON_PACKAGE_ARGS "REQUIRED" COMMON_PACKAGE_REQUIRED_POS)
  if(COMMON_PACKAGE_REQUIRED_POS EQUAL -1) # Optional find
    find_package(${Name} ${COMMON_PACKAGE_ARGS}) # try standard cmake way
    if((NOT ${Name}_FOUND) AND (NOT ${COMMON_PACKAGE_NAME}_FOUND) AND PKG_CONFIG_EXECUTABLE)
      pkg_check_modules(${Name} ${Name}${COMMON_PACKAGE_VERSION}
        ${COMMON_PACKAGE_QUIET}) # try pkg_config way
    endif()
  else() # required find
    list(REMOVE_AT COMMON_PACKAGE_ARGS ${COMMON_PACKAGE_REQUIRED_POS})
    find_package(${Name} ${COMMON_PACKAGE_ARGS}) # try standard cmake way
    if((NOT ${Name}_FOUND) AND (NOT ${COMMON_PACKAGE_NAME}_FOUND) AND PKG_CONFIG_EXECUTABLE)
      pkg_check_modules(${Name} REQUIRED ${Name}${COMMON_PACKAGE_VERSION}
        ${COMMON_PACKAGE_QUIET}) # try pkg_config way (and fail if needed)
    endif()
  endif()
endmacro()

set(_req)
set(_quiet)
set(Collage_fail)
set(COLLAGE_COMPONENTS)
if(NOT COLLAGE_FOUND)
  set(COLLAGE_STATUS ON)
else()
  set(COLLAGE_STATUS)
endif()

if(Collage_FIND_REQUIRED)
  set(_req REQUIRED)
endif()
if(Collage_FIND_QUIETLY)
  set(_quiet QUIET)
endif()

set(_LUNCHBOX_libraries_backup ${LUNCHBOX_LIBRARIES})
set(_LUNCHBOX_found_backup ${LUNCHBOX_FOUND})
set(LUNCHBOX_LIBRARIES)
set(LUNCHBOX_FOUND)
common_package(Lunchbox 1.10 QUIET ${_req} )
if(LUNCHBOX_FOUND)
  set(COLLAGE_LUNCHBOX_LIBRARIES ${LUNCHBOX_LIBRARIES})
  set(COLLAGE_LUNCHBOX_FOUND TRUE)
  if(NOT ${LUNCHBOX_VERSION_ABI} VERSION_EQUAL 3)
    message(FATAL_ERROR "LUNCHBOX ABI version '${LUNCHBOX_VERSION_ABI}' not compatible with expected version '3'")
  endif()
  list(APPEND COLLAGE_DEP_LIBRARIES ${LUNCHBOX_LIBRARIES})
  list(APPEND COLLAGE_INCLUDE_DIRS ${LUNCHBOX_INCLUDE_DIRS})
else()
  set(Collage_fail "Lunchbox ")
endif()
set(LUNCHBOX_LIBRARIES ${_LUNCHBOX_libraries_backup})
set(LUNCHBOX_FOUND ${_LUNCHBOX_found_backup})

set(COLLAGE_FIND_FILES )
set(_output_type)
set(_out)
if(Collage_FIND_REQUIRED)
  set(_output_type FATAL_ERROR)
  set(_out 1)
else()
  set(_output_type STATUS)
  if(NOT Collage_FIND_QUIETLY)
    set(_out 1)
  endif()
endif()
if(NOT Collage_fail)
  list(APPEND COLLAGE_INCLUDE_DIRS ${Collage_PREFIX_DIR}/include)
  set(COLLAGE_DEB_DEPENDENCIES "collage2 (>= 1.1)")
  set(COLLAGE_DEB_LIB_DEPENDENCY "collage2-lib (>= 1.1)")
  set(COLLAGE_DEB_DEV_DEPENDENCY "collage2-dev (>= 1.1)")

  if(Collage_FIND_COMPONENTS)
    find_library(${UPPER_PROJECT_NAME}_LIBRARY Collage NO_DEFAULT_PATH
                 PATHS ${Collage_PREFIX_DIR} PATH_SUFFIXES lib )
    list(APPEND COLLAGE_LIBRARIES ${COLLAGE_LIBRARY})
    foreach(_component ${Collage_FIND_COMPONENTS})
      find_library(${_component}_libraryname Collage_${_component} NO_DEFAULT_PATH
        PATHS ${Collage_PREFIX_DIR} PATH_SUFFIXES lib )

      if(${_component}_libraryname MATCHES "${_component}_libraryname-NOTFOUND")
        if(Collage_FIND_REQUIRED_${_component})
          set(Collage_fail "Component ${_component} ")
          message(FATAL_ERROR "   Collage_${_component} "
            "not found in ${Collage_PREFIX_DIR}/lib")
        elseif(NOT _quiet)
          message(STATUS "   Collage_${_component} "
            "not found in ${Collage_PREFIX_DIR}/lib")
        endif()
      else()
        string(TOUPPER ${_component} _COMPONENT)
        set(COLLAGE_${_COMPONENT}_FOUND TRUE)
        set(COLLAGE_${_COMPONENT}_LIBRARY ${${_component}_libraryname})
        list(APPEND COLLAGE_LIBRARIES ${${_component}_libraryname})
        list(APPEND COLLAGE_COMPONENTS ${_component})
      endif()
    endforeach()
  elseif(COLLAGE_FIND_FILES)
    find_file(COLLAGE_FILE NAMES  NO_DEFAULT_PATH
              PATHS ${Collage_PREFIX_DIR} PATH_SUFFIXES include)
    if(COLLAGE_FILE MATCHES "COLLAGE_FILE-NOTFOUND")
      set(Collage_fail " ")
      if(_out)
        message(${_output_type} "   Missing the Collage "
          "file in ${Collage_PREFIX_DIR}/include.")
      endif()
    endif()
  else()
    set(COLLAGE_LIBRARY_NAMES "Collage")
    foreach(_libraryname ${COLLAGE_LIBRARY_NAMES})
      string(TOUPPER ${_libraryname} _LIBRARYNAME)
      find_library(${_LIBRARYNAME}_LIBRARY ${_libraryname} NO_DEFAULT_PATH
                   PATHS ${Collage_PREFIX_DIR} PATH_SUFFIXES lib )
      if(${_LIBRARYNAME}_LIBRARY MATCHES "${_LIBRARYNAME}_LIBRARY-NOTFOUND")
        set(Collage_fail "${_libraryname} ")
        if(_out)
          message(${_output_type}
            "   Missing ${_libraryname} in ${Collage_PREFIX_DIR}/lib")
        endif()
      else()
        list(APPEND COLLAGE_LIBRARIES ${${_LIBRARYNAME}_LIBRARY})
        string(REPLACE "Collage_" "" _component ${_libraryname})
        string(TOUPPER ${_component} _COMPONENT)
        set(COLLAGE_${_COMPONENT}_FOUND TRUE)
        list(APPEND COLLAGE_COMPONENTS ${_component})
      endif()
    endforeach()
  endif()

  if(EXISTS ${Collage_PREFIX_DIR}/share/Collage/CMake/options.cmake)
    include(${Collage_PREFIX_DIR}/share/Collage/CMake/options.cmake)
  endif()
endif()

list(APPEND COLLAGE_LIBRARIES ${COLLAGE_DEP_LIBRARIES})
set(COLLAGE_DEP_LIBRARIES)
if(Collage_fail)
  set(COLLAGE_FOUND)
  set(Collage_FOUND)
  set(COLLAGE_VERSION)
  set(COLLAGE_VERSION_ABI)
  set(COLLAGE_INCLUDE_DIRS)
  set(COLLAGE_LIBRARIES)
  set(COLLAGE_DEB_DEPENDENCIES)
  set(COLLAGE_LIBRARY)
  set(COLLAGE_COMPONENTS)
  if(_out)
    message(STATUS "Could not find Collage: ${Collage_fail} not found")
  endif()
else()
  set(COLLAGE_FOUND TRUE)
  set(Collage_FOUND TRUE)
  set(COLLAGE_VERSION 1.1.2)
  set(COLLAGE_VERSION_ABI 2)
  set(COLLAGE_MODULE_FILENAME )
  list(SORT COLLAGE_INCLUDE_DIRS)
  list(REMOVE_DUPLICATES COLLAGE_INCLUDE_DIRS)
  if(COLLAGE_LIBRARIES)
    list(REMOVE_DUPLICATES COLLAGE_LIBRARIES)
  endif()
  if(_out AND COLLAGE_STATUS)
    message(STATUS "Found Collage 1.1.2-2 [${COLLAGE_COMPONENTS}] in "
      "${COLLAGE_INCLUDE_DIRS}:${COLLAGE_LIBRARY}")
  endif()
endif()
